﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

# <rtc-template block="description">
"""
 @file MotionDetermComp.py
 @brief Determine the next motion of G-ROBOTS
 @date $Date$

 @author Mahiro Sawada <m.sawada@toki.waseda.jp>

"""
# </rtc-template>

import sys
import time
sys.path.append(".")

# Import RTM module
import RTC
import OpenRTM_aist


# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
motiondetermcomp_spec = ["implementation_id", "MotionDetermComp", 
         "type_name",         "MotionDetermComp", 
         "description",       "Determine the next motion of G-ROBOTS", 
         "version",           "1.0.0", 
         "vendor",            "MP", 
         "category",          "Robot", 
         "activity_type",     "STATIC", 
         "max_instance",      "1", 
         "language",          "Python", 
         "lang_type",         "SCRIPT",
         ""]
# </rtc-template>

# <rtc-template block="component_description">
##
# @class MotionDetermComp
# @brief Determine the next motion of G-ROBOTS
# 
# 
# </rtc-template>
class MotionDetermComp(OpenRTM_aist.DataFlowComponentBase):
	
    ##
    # @brief constructor
    # @param manager Maneger Object
    # 
    def __init__(self, manager):
        OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

        self._d_posture_tgt = OpenRTM_aist.instantiateDataType(RTC.TimedString)
        """
        """
        self._posePatternIn = OpenRTM_aist.InPort("posePattern", self._d_posture_tgt)
        self._d_dist_tgt = OpenRTM_aist.instantiateDataType(RTC.TimedDouble)
        """
        """
        self._distanceIn = OpenRTM_aist.InPort("distance", self._d_dist_tgt)
        self._d_move = OpenRTM_aist.instantiateDataType(RTC.TimedString)
        """
        """
        self._movePatternOut = OpenRTM_aist.OutPort("movePattern", self._d_move)


		


        # initialize of configuration-data.
        # <rtc-template block="init_conf_param">
		
        # </rtc-template>


		 
    ##
    #
    # The initialize action (on CREATED->ALIVE transition)
    # 
    # @return RTC::ReturnCode_t
    # 
    #
    def onInitialize(self):
        # Bind variables and configuration variable
		
        # Set InPort buffers
        self.addInPort("posePattern",self._posePatternIn)
        self.addInPort("distance",self._distanceIn)
		
        # Set OutPort buffers
        self.addOutPort("movePattern",self._movePatternOut)
		
        # Set service provider to Ports
		
        # Set service consumers to Ports
		
        # Set CORBA Service Ports
		
        return RTC.RTC_OK
	
    ###
    ## 
    ## The finalize action (on ALIVE->END transition)
    ## 
    ## @return RTC::ReturnCode_t
    #
    ## 
    #def onFinalize(self):
    #

    #    return RTC.RTC_OK
	
    ###
    ##
    ## The startup action when ExecutionContext startup
    ## 
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onStartup(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The shutdown action when ExecutionContext stop
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onShutdown(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ##
    #
    # The activated action (Active state entry action)
    #
    # @param ec_id target ExecutionContext Id
    # 
    # @return RTC::ReturnCode_t
    #
    #
    def onActivated(self, ec_id):
        self.movePrv = "Init"
        self.now = time.time() + 10
        return RTC.RTC_OK
	
    ##
    #
    # The deactivated action (Active state exit action)
    #
    # @param ec_id target ExecutionContext Id
    #
    # @return RTC::ReturnCode_t
    #
    #
    def onDeactivated(self, ec_id):
    
        return RTC.RTC_OK
	
    ##
    #
    # The execution action that is invoked periodically
    #
    # @param ec_id target ExecutionContext Id
    #
    # @return RTC::ReturnCode_t
    #
    #
    def onExecute(self, ec_id):
        ##initialize input variables
        #if self._distanceIn.isNew():
        #    self._d_dist_tgt = self._distanceIn.read()
        #    print(self._d_dist_tgt)
#
        #if self._posePatternIn.isNew():
        #    self._d_posture_tgt = self._posePatternIn.read()
        #    print(self._d_posture_tgt)
#
        ##if the current time is closer to when the previous command sent than 4 sec, abort
        #if time.time() - self.now < 4:
        #        return RTC.RTC_OK
#
        ##check if the person is centered
        #if abs(self._d_dist_tgt.data) > 100:
        #    #decide rotation direction
        #    if self._d_dist_tgt.data > 0:
        #        self._d_move.data = "r"
        #    else:
        #        self._d_move.data = "l"
#
        #    #create and send rotation command
        #    self._d_move.data = self._d_move.data + "Rotate"
        #    self.movePrv = self._d_move.data #save the move for "previous move"
        #    self.now = time.time() #record the time when sending the command
        #    self._movePatternOut.write()
        #        
        #else: #if the person is centered, do target posture
        #        self._d_move.data = self._d_posture_tgt.data
        #        #send command if the command is not None and different from previous move
        #        if self._d_move.data != 'None' and self._d_move.data != self.movePrv:
        #            self.movePrv = self._d_move.data
        #            self.now = time.time()
        #            self._movePatternOut.write()
        #return RTC.RTC_OK

        #initialize input variables
        if self._distanceIn.isNew():
            self._d_dist_tgt = self._distanceIn.read()
            print(self._d_dist_tgt)

        if self._posePatternIn.isNew():
            self._d_posture_tgt = self._posePatternIn.read()
            print(self._d_posture_tgt)

        #if the current time is closer to when the previous command sent than 4 sec, abort
        tDiff = time.time() - self.now
        if self.movePrv in ["lRotate", "rRotate"]:
            if tDiff < 4:
                return RTC.RTC_OK
        elif tDiff < 1.5:
            return RTC.RTC_OK

        #check if the person is centered
        if abs(self._d_dist_tgt.data) > 100:
            #decide rotation direction
            if self._d_dist_tgt.data > 0:
                self._d_move.data = "r"
            else:
                self._d_move.data = "l"

            #create and send rotation command
            self._d_move.data = self._d_move.data + "Rotate"
            self.movePrv = self._d_move.data #save the move for "previous move"
            self.now = time.time() #record the time when sending the command
            self._movePatternOut.write()
                
        else: #if the person is centered, do target posture
                self._d_move.data = self._d_posture_tgt.data
                #send command if the command is not None and different from previous move
                if self._d_move.data != 'None' and self._d_move.data != self.movePrv:
                    self.movePrv = self._d_move.data
                    self.now = time.time()
                    self._movePatternOut.write()
        return RTC.RTC_OK
    ###
    ##
    ## The aborting action when main logic error occurred.
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onAborting(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The error action in ERROR state
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onError(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The reset action that is invoked resetting
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onReset(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The state update action that is invoked after onExecute() action
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##

    ##
    #def onStateUpdate(self, ec_id):
    #
    #    return RTC.RTC_OK
	
    ###
    ##
    ## The action that is invoked when execution context's rate is changed
    ##
    ## @param ec_id target ExecutionContext Id
    ##
    ## @return RTC::ReturnCode_t
    ##
    ##
    #def onRateChanged(self, ec_id):
    #
    #    return RTC.RTC_OK
	



def MotionDetermCompInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=motiondetermcomp_spec)
    manager.registerFactory(profile,
                            MotionDetermComp,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    MotionDetermCompInit(manager)

    # create instance_name option for createComponent()
    instance_name = [i for i in sys.argv if "--instance_name=" in i]
    if instance_name:
        args = instance_name[0].replace("--", "?")
    else:
        args = ""
  
    # Create a component
    comp = manager.createComponent("MotionDetermComp" + args)

def main():
    # remove --instance_name= option
    argv = [i for i in sys.argv if not "--instance_name=" in i]
    # Initialize manager
    mgr = OpenRTM_aist.Manager.init(sys.argv)
    mgr.setModuleInitProc(MyModuleInit)
    mgr.activateManager()
    mgr.runManager()

if __name__ == "__main__":
    main()

